package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLMapToBasicSetMap_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLMapToBasicSetMap extends JNIObject  {
	
	/* @generated */
	protected ISLMapToBasicSetMap(long ptr) {
		/*** PROTECTED REGION ID(ISLMapToBasicSetMap_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLMapToBasicSetMap build(long ptr) {
		return new ISLMapToBasicSetMap(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLMapToBasicSetMap_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_map_to_basic_set_alloc 
	 * 
	 * @generated
	**/
	 public static ISLMapToBasicSetMap alloc(ISLContext ctx, int min_size) { 
		/*** PROTECTED REGION ID(static_isl_map_to_basic_set_alloc) DISABLED START ***/
		ISLMapToBasicSetMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMapToBasicSetMap.build(ISLNative.isl_map_to_basic_set_alloc(getNativePtr(ctx), min_size));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_basic_set_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLMapToBasicSetMap map2bset, int format) { 
		/*** PROTECTED REGION ID(static_isl_map_to_basic_set_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_to_basic_set_to_string(getNativePtr(map2bset), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_map_to_basic_set_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_map_to_basic_set_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_map_to_basic_set_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_basic_set_copy 
	 * 
	 * @generated
	**/
	public ISLMapToBasicSetMap copy() {
		/*** PROTECTED REGION ID(isl_map_to_basic_set_copy) DISABLED START ***/
		ISLMapToBasicSetMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMapToBasicSetMap.build(ISLNative.isl_map_to_basic_set_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_basic_set_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_map_to_basic_set_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_map_to_basic_set_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_basic_set_has 
	 * 
	 * @generated
	**/
	public boolean containsKey(ISLMap key) {
		/*** PROTECTED REGION ID(isl_map_to_basic_set_has) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_map_to_basic_set_has(getNativePtr(this), getNativePtr(key)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_basic_set_get 
	 * 
	 * @take key
	 * @generated
	**/
	public ISLBasicSet get(ISLMap key) {
		/*** PROTECTED REGION ID(isl_map_to_basic_set_get) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(key);
			try {
				res = ISLBasicSet.build(ISLNative.isl_map_to_basic_set_get(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_basic_set_set 
	 * 
	 * @take this key val
	 * @generated
	**/
	public ISLMapToBasicSetMap put(ISLMap key, ISLBasicSet val) {
		/*** PROTECTED REGION ID(isl_map_to_basic_set_set) DISABLED START ***/
		ISLMapToBasicSetMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key, val);
			try {
				res = ISLMapToBasicSetMap.build(ISLNative.isl_map_to_basic_set_set(getNativePtr(this), getNativePtr(key), getNativePtr(val)));
			} finally {
				taken(this);
				taken(key);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_to_basic_set_drop 
	 * 
	 * @take this key
	 * @generated
	**/
	public ISLMapToBasicSetMap remove(ISLMap key) {
		/*** PROTECTED REGION ID(isl_map_to_basic_set_drop) DISABLED START ***/
		ISLMapToBasicSetMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key);
			try {
				res = ISLMapToBasicSetMap.build(ISLNative.isl_map_to_basic_set_drop(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(this);
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLMapToBasicSetMap_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
